//soldier

/* CVARS - copy and paste to shconfig.cfg 

//soldier
soldier_level 15                  // Level of soldier
soldier_teamglow 1            // Does He Glow? 
soldier_augmult 2.5          // Damage Multiplier For His aug
soldier_health 100              // Amount of HP he has 
soldier_armor 100              // Amount of AP he has 
soldier_gravity 0.20              // Whats his gravity? 
soldier_speed 990               // How fast does he run 

*/ 

#include <amxmod> 
#include <vexd_utilities> 
#include <superheromod> 

// GLOBAL VARIABLES 
new gHeroName[]="soldier" 
new bool:gHassoldierPower[SH_MAXSLOTS+1] 
new bool:gmorphed[SH_MAXSLOTS+1] 
new gTaskID 
//---------------------------------------------------------------------------------------------- 
public plugin_init() 
{ 
   // Plugin Info 
   register_plugin("SUPERHERO soldier", "1.0", "Om3gA") 

   // DO NOT EDIT THIS FILE TO CHANGE/ CVARS, USE THE SHCONFIG.CFG 
   register_cvar("soldier_level", "10") 
   register_cvar("soldier_teamglow", "1") 
   register_cvar("soldier_augmult", "2.5") 
   register_cvar("soldier_health", "100") 
   register_cvar("soldier_armor", "100") 
   register_cvar("soldier_gravity", "0.20") 
   register_cvar("soldier_speed", "990") 

   // FIRE THE EVENT TO CREATE THIS SUPERHERO! 
   shCreateHero(gHeroName, "soldier", "soldier from the game nature selection", false, "soldier_level" ) 

   // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS) 
   // INIT 
   register_srvcmd("soldier_init", "soldier_init") 
   shRegHeroInit(gHeroName, "soldier_init") 

   register_event("ResetHUD", "newSpawn", "b") 
   register_event("CurWeapon", "weaponChange", "be", "1=1") 
   register_event("Damage", "soldier_damage", "b", "2!0") 
   register_event("DeathMsg", "soldier_death", "a") 

   //Set a random number to the looping task so it can be removed without conflict
   gTaskID = random_num(10181, 100000) 

   // Let Server know about LiTo's Variables 
   shSetShieldRestrict(gHeroName) 
   shSetMaxHealth(gHeroName, "soldier_health") 
   shSetMaxArmor(gHeroName, "soldier_armor") 
   shSetMinGravity(gHeroName, "soldier_gravity") 
   shSetMaxSpeed(gHeroName, "soldier_speed", "[0]") 
} 
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_model("models/shmod/soldier_aug.mdl")
	precache_model("models/player/soldier/soldier.mdl")
}
//---------------------------------------------------------------------------------------------- 
public soldier_init() 
{ 
   // First Argument is an id 
   new temp[6] 
   read_argv(1,temp,5) 
   new id = str_to_num(temp) 

   // 2nd Argument is 0 or 1 depending on whether the id has sntJh
   read_argv(2,temp,5) 
   new hasPowers = str_to_num(temp) 

   gHassoldierPower[id] = (hasPowers != 0) 

   //Reset thier shield restrict status 
   //Shield restrict MUST be before weapons are given out 
   shResetShield(id) 

   if ( is_user_connected(id) ) { 
      if ( gHassoldierPower[id] ) { 
         soldier_weapons(id)  
        soldier_tasks(id) 
      } 
      else { 
         engclient_cmd(id, "drop", "weapon_aug") 
         soldier_unmorph(id) 
         shRemHealthPower(id) 
         shRemArmorPower(id) 
         shRemGravityPower(id) 
         shRemSpeedPower(id) 
      } 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public newSpawn(id) 
{ 
   if ( gHassoldierPower[id] && is_user_alive(id) && shModActive() ) { 
      set_task(0.1, "soldier_weapons", id) 
      soldier_tasks(id) 

      new wpnid = read_data(2) 
      if (wpnid != CSW_AUG && wpnid > 0) { 
         new wpn[32] 
         get_weaponname(wpnid,wpn,31) 
         engclient_cmd(id,wpn) 
      } 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_tasks(id) 
{ 
   set_task(1.0, "soldier_morph", id) 

   if( get_cvar_num("soldier_teamglow") ){ 
      set_task(1.0, "soldier_glow", id+gTaskID, "", 0, "b" ) 
   } 

} 
//---------------------------------------------------------------------------------------------- 
public soldier_weapons(id) 
{ 
   if ( is_user_alive(id) ) { 
      shGiveWeapon(id,"weapon_aug") 
   } 
} 
//-----------------------------------------------------------------------------------------------
public switchmodel(id)
{
	if ( !is_user_alive(id) || !gHassoldierPower[id] ) return

	new clip, ammo, wpnid = get_user_weapon(id,clip,ammo)
	if (wpnid == CSW_AUG) {
		// Weapon Model change thanks to [CCC]Taz-Devil
		Entvars_Set_String(id, EV_SZ_viewmodel, "models/shmod/soldier_aug.mdl")
	}
}
//----------------------------------------------------------------------------------------------  
public weaponChange(id) 
{ 
   if ( !gHassoldierPower[id] || !shModActive() ) return 

   new wpnid = read_data(2) 
   new clip = read_data(3) 

   if ( wpnid != CSW_AUG ) return  

   // Never Run Out of Ammo! 
   if ( clip == 0 ) { 
      shReloadAmmo(id) 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_damage(id) 
{ 
   if (!shModActive() || !is_user_alive(id)) return 

   new damage = read_data(2) 
   new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart) 
   new headshot = bodypart == 1 ? 1 : 0 

   if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return 

   if ( gHassoldierPower[attacker] && weapon == CSW_AUG && is_user_alive(id) ) { 
      // do extra damage 
      new extraDamage = floatround(damage * get_cvar_float("soldier_augmult") - damage) 
      if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "aug", headshot ) 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_morph(id) 
{ 
   if ( gmorphed[id] || !is_user_alive(id) ) return 

   #if defined AMXX_VERSION 
   cs_set_user_model(id, "soldier") 
   #else 
   CS_SetModel(id, "soldier") 
   #endif 

   // Message 
   set_hudmessage(50, 205, 50, -1.0, 0.40, 2, 0.02, 4.0, 0.01, 0.1, 7) 
   show_hudmessage(id, "soldier") 

   gmorphed[id] = true 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_unmorph(id) 
{ 
   if ( gmorphed[id] ) { 
      // Message 
      set_hudmessage(50, 205, 50, -1.0, 0.40, 2, 0.02, 4.0, 0.01, 0.1, 7) 
      show_hudmessage(id, "soldier Down!!!") 

      #if defined AMXX_VERSION 
      cs_reset_user_model(id) 
      #else 
      CS_ClearModel(id) 
      #endif 

      gmorphed[id] = false 

      if ( get_cvar_num("soldier_teamglow") ) { 
         remove_task(id+gTaskID) 
         set_user_rendering(id) 
      } 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_glow(id) 
{ 
   id -= gTaskID 

   if ( !is_user_connected(id) ) { 
      //Don't want any left over residuals 
      remove_task(id+gTaskID) 
      return 
   } 

   if ( gHassoldierPower[id] && is_user_alive(id)) { 
      if ( get_user_team(id) == 1 ) { 
         shGlow(id, 255, 0, 0) 
      } 
      else { 
         shGlow(id, 0, 0, 255) 
      } 
   } 
} 
//---------------------------------------------------------------------------------------------- 
public soldier_death() 
{ 
   new id = read_data(2) 
   soldier_unmorph(id) 
} 
//---------------------------------------------------------------------------------------------- 
public client_connect(id) 
{ 
   gmorphed[id] = false 
} 
//----------------------------------------------------------------------------------------------